use eyes::parse;

fn main() {
    let input = std::fs::read_to_string("input/day4.txt").unwrap();
    println!("part 1: {}", part1(&input));
    println!("part 1: {}", part2(&input));
}

fn part1(input: &str) -> i64 {
    input
        .lines()
        .map(|line| parse!(line, "{}-{},{}-{}", i64, i64, i64, i64))
        .filter(|(f1, f2, s1, s2)| (f1 <= s1 && f2 >= s2) || (s1 <= f1 && s2 >= f2))
        .count() as i64
}

fn part2(input: &str) -> i64 {
    input
        .lines()
        .map(|line| parse!(line, "{}-{},{}-{}", i64, i64, i64, i64))
        .filter(|(f1, f2, s1, s2)| f2 >= s1 && s2 >= f1)
        .count() as i64
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn examples() {
        let example = "2-4,6-8\n2-3,4-5\n5-7,7-9\n2-8,3-7\n6-6,4-6\n2-6,4-8";
        assert_eq!(part1(example), 2);
        assert_eq!(part2(example), 4);
    }
}
